# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.Ouid do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :OrganizationStatus,
    :ChangedByMemberKeyNumeric,
    :OrganizationAorOuidKeyNumeric,
    :OrganizationMemberCount,
    :OrganizationUniqueIdKeyNumeric,
    :ChangedByMemberID,
    :ChangedByMemberKey,
    :OrganizationAddress1,
    :OrganizationAddress2,
    :OrganizationAorOuid,
    :OrganizationAorOuidKey,
    :OrganizationCarrierRoute,
    :OrganizationCity,
    :OrganizationComments,
    :OrganizationContactEmail,
    :OrganizationContactFax,
    :OrganizationContactFirstName,
    :OrganizationContactFullName,
    :OrganizationContactJobTitle,
    :OrganizationContactLastName,
    :OrganizationContactMiddleName,
    :OrganizationContactNamePrefix,
    :OrganizationContactNameSuffix,
    :OrganizationContactPhone,
    :OrganizationContactPhoneExt,
    :OrganizationMlsCode,
    :OrganizationMlsVendorName,
    :OrganizationMlsVendorOuid,
    :OrganizationName,
    :OrganizationNationalAssociationId,
    :OrganizationPostalCode,
    :OrganizationPostalCodePlus4,
    :OrganizationStateLicense,
    :OrganizationUniqueId,
    :OrganizationUniqueIdKey,
    :OrganizationAOR,
    :OrganizationCountry,
    :OrganizationCountyOrParish,
    :OrganizationSocialMediaType,
    :OrganizationStateLicenseState,
    :OrganizationStateOrProvince,
    :OrganizationType,
    :ModificationTimestamp,
    :OrganizationStatusChangeTimestamp,
    :OriginalEntryTimestamp,
    :ChangedByMember,
    :OriginatingSystemContacts,
    :SourceSystemContacts,
    :OriginatingSystemHistoryTransactionals,
    :SourceSystemHistoryTransactionals,
    :ActorOriginatingSystemInternetTrackings,
    :ActorSourceSystemInternetTrackings,
    :EventOriginatingSystemInternetTrackings,
    :EventSourceSystemInternetTrackings,
    :ObjectOriginatingSystemInternetTrackings,
    :ObjectSourceSystemInternetTrackings,
    :OriginatingSystemMembers,
    :SourceSystemMembers,
    :OriginatingSystemOffices,
    :SourceSystemOffices,
    :OriginatingSystemOpenHouses,
    :SourceSystemOpenHouses,
    :OriginatingSystemProperties,
    :SourceSystemProperties,
    :OriginatingSystemQueues,
    :SourceSystemQueues,
    :OriginatingSystemRules,
    :SourceSystemRules,
    :OriginatingSystemSavedSearches,
    :SourceSystemSavedSearches,
    :AgentOriginatingSystemShowings,
    :AgentSourceSystemShowings,
    :ListingOriginatingSystemShowings,
    :ListingSourceSystemShowings,
    :ShowingOriginatingSystemShowings,
    :ShowingSourceSystemShowings,
    :OriginatingSystemTeamMembers,
    :SourceSystemTeamMembers,
    :OriginatingSystemTeams,
    :SourceSystemTeams
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :OrganizationStatus => boolean() | nil,
    :ChangedByMemberKeyNumeric => float() | nil,
    :OrganizationAorOuidKeyNumeric => float() | nil,
    :OrganizationMemberCount => float() | nil,
    :OrganizationUniqueIdKeyNumeric => float() | nil,
    :ChangedByMemberID => String.t | nil,
    :ChangedByMemberKey => String.t | nil,
    :OrganizationAddress1 => String.t | nil,
    :OrganizationAddress2 => String.t | nil,
    :OrganizationAorOuid => String.t | nil,
    :OrganizationAorOuidKey => String.t | nil,
    :OrganizationCarrierRoute => String.t | nil,
    :OrganizationCity => String.t | nil,
    :OrganizationComments => String.t | nil,
    :OrganizationContactEmail => String.t | nil,
    :OrganizationContactFax => String.t | nil,
    :OrganizationContactFirstName => String.t | nil,
    :OrganizationContactFullName => String.t | nil,
    :OrganizationContactJobTitle => String.t | nil,
    :OrganizationContactLastName => String.t | nil,
    :OrganizationContactMiddleName => String.t | nil,
    :OrganizationContactNamePrefix => String.t | nil,
    :OrganizationContactNameSuffix => String.t | nil,
    :OrganizationContactPhone => String.t | nil,
    :OrganizationContactPhoneExt => String.t | nil,
    :OrganizationMlsCode => String.t | nil,
    :OrganizationMlsVendorName => String.t | nil,
    :OrganizationMlsVendorOuid => String.t | nil,
    :OrganizationName => String.t | nil,
    :OrganizationNationalAssociationId => String.t | nil,
    :OrganizationPostalCode => String.t | nil,
    :OrganizationPostalCodePlus4 => String.t | nil,
    :OrganizationStateLicense => String.t | nil,
    :OrganizationUniqueId => String.t | nil,
    :OrganizationUniqueIdKey => String.t | nil,
    :OrganizationAOR => String.t | nil,
    :OrganizationCountry => String.t | nil,
    :OrganizationCountyOrParish => String.t | nil,
    :OrganizationSocialMediaType => String.t | nil,
    :OrganizationStateLicenseState => String.t | nil,
    :OrganizationStateOrProvince => String.t | nil,
    :OrganizationType => String.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :OrganizationStatusChangeTimestamp => Date.t | nil,
    :OriginalEntryTimestamp => Date.t | nil,
    :ChangedByMember => FoyerAPI.Model.Member.t | nil,
    :OriginatingSystemContacts => [FoyerAPI.Model.Contacts.t] | nil,
    :SourceSystemContacts => [FoyerAPI.Model.Contacts.t] | nil,
    :OriginatingSystemHistoryTransactionals => [FoyerAPI.Model.HistoryTransactional.t] | nil,
    :SourceSystemHistoryTransactionals => [FoyerAPI.Model.HistoryTransactional.t] | nil,
    :ActorOriginatingSystemInternetTrackings => [FoyerAPI.Model.InternetTracking.t] | nil,
    :ActorSourceSystemInternetTrackings => [FoyerAPI.Model.InternetTracking.t] | nil,
    :EventOriginatingSystemInternetTrackings => [FoyerAPI.Model.InternetTracking.t] | nil,
    :EventSourceSystemInternetTrackings => [FoyerAPI.Model.InternetTracking.t] | nil,
    :ObjectOriginatingSystemInternetTrackings => [FoyerAPI.Model.InternetTracking.t] | nil,
    :ObjectSourceSystemInternetTrackings => [FoyerAPI.Model.InternetTracking.t] | nil,
    :OriginatingSystemMembers => [FoyerAPI.Model.Member.t] | nil,
    :SourceSystemMembers => [FoyerAPI.Model.Member.t] | nil,
    :OriginatingSystemOffices => [FoyerAPI.Model.Office.t] | nil,
    :SourceSystemOffices => [FoyerAPI.Model.Office.t] | nil,
    :OriginatingSystemOpenHouses => [FoyerAPI.Model.OpenHouse.t] | nil,
    :SourceSystemOpenHouses => [FoyerAPI.Model.OpenHouse.t] | nil,
    :OriginatingSystemProperties => [FoyerAPI.Model.Property.t] | nil,
    :SourceSystemProperties => [FoyerAPI.Model.Property.t] | nil,
    :OriginatingSystemQueues => [FoyerAPI.Model.Queue.t] | nil,
    :SourceSystemQueues => [FoyerAPI.Model.Queue.t] | nil,
    :OriginatingSystemRules => [FoyerAPI.Model.Rules.t] | nil,
    :SourceSystemRules => [FoyerAPI.Model.Rules.t] | nil,
    :OriginatingSystemSavedSearches => [FoyerAPI.Model.SavedSearch.t] | nil,
    :SourceSystemSavedSearches => [FoyerAPI.Model.SavedSearch.t] | nil,
    :AgentOriginatingSystemShowings => [FoyerAPI.Model.Showing.t] | nil,
    :AgentSourceSystemShowings => [FoyerAPI.Model.Showing.t] | nil,
    :ListingOriginatingSystemShowings => [FoyerAPI.Model.Showing.t] | nil,
    :ListingSourceSystemShowings => [FoyerAPI.Model.Showing.t] | nil,
    :ShowingOriginatingSystemShowings => [FoyerAPI.Model.Showing.t] | nil,
    :ShowingSourceSystemShowings => [FoyerAPI.Model.Showing.t] | nil,
    :OriginatingSystemTeamMembers => [FoyerAPI.Model.TeamMembers.t] | nil,
    :SourceSystemTeamMembers => [FoyerAPI.Model.TeamMembers.t] | nil,
    :OriginatingSystemTeams => [FoyerAPI.Model.Teams.t] | nil,
    :SourceSystemTeams => [FoyerAPI.Model.Teams.t] | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.Ouid do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:OrganizationStatusChangeTimestamp, :date, nil, options)
    |> deserialize(:OriginalEntryTimestamp, :date, nil, options)
    |> deserialize(:ChangedByMember, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:OriginatingSystemContacts, :list, FoyerAPI.Model.Contacts, options)
    |> deserialize(:SourceSystemContacts, :list, FoyerAPI.Model.Contacts, options)
    |> deserialize(:OriginatingSystemHistoryTransactionals, :list, FoyerAPI.Model.HistoryTransactional, options)
    |> deserialize(:SourceSystemHistoryTransactionals, :list, FoyerAPI.Model.HistoryTransactional, options)
    |> deserialize(:ActorOriginatingSystemInternetTrackings, :list, FoyerAPI.Model.InternetTracking, options)
    |> deserialize(:ActorSourceSystemInternetTrackings, :list, FoyerAPI.Model.InternetTracking, options)
    |> deserialize(:EventOriginatingSystemInternetTrackings, :list, FoyerAPI.Model.InternetTracking, options)
    |> deserialize(:EventSourceSystemInternetTrackings, :list, FoyerAPI.Model.InternetTracking, options)
    |> deserialize(:ObjectOriginatingSystemInternetTrackings, :list, FoyerAPI.Model.InternetTracking, options)
    |> deserialize(:ObjectSourceSystemInternetTrackings, :list, FoyerAPI.Model.InternetTracking, options)
    |> deserialize(:OriginatingSystemMembers, :list, FoyerAPI.Model.Member, options)
    |> deserialize(:SourceSystemMembers, :list, FoyerAPI.Model.Member, options)
    |> deserialize(:OriginatingSystemOffices, :list, FoyerAPI.Model.Office, options)
    |> deserialize(:SourceSystemOffices, :list, FoyerAPI.Model.Office, options)
    |> deserialize(:OriginatingSystemOpenHouses, :list, FoyerAPI.Model.OpenHouse, options)
    |> deserialize(:SourceSystemOpenHouses, :list, FoyerAPI.Model.OpenHouse, options)
    |> deserialize(:OriginatingSystemProperties, :list, FoyerAPI.Model.Property, options)
    |> deserialize(:SourceSystemProperties, :list, FoyerAPI.Model.Property, options)
    |> deserialize(:OriginatingSystemQueues, :list, FoyerAPI.Model.Queue, options)
    |> deserialize(:SourceSystemQueues, :list, FoyerAPI.Model.Queue, options)
    |> deserialize(:OriginatingSystemRules, :list, FoyerAPI.Model.Rules, options)
    |> deserialize(:SourceSystemRules, :list, FoyerAPI.Model.Rules, options)
    |> deserialize(:OriginatingSystemSavedSearches, :list, FoyerAPI.Model.SavedSearch, options)
    |> deserialize(:SourceSystemSavedSearches, :list, FoyerAPI.Model.SavedSearch, options)
    |> deserialize(:AgentOriginatingSystemShowings, :list, FoyerAPI.Model.Showing, options)
    |> deserialize(:AgentSourceSystemShowings, :list, FoyerAPI.Model.Showing, options)
    |> deserialize(:ListingOriginatingSystemShowings, :list, FoyerAPI.Model.Showing, options)
    |> deserialize(:ListingSourceSystemShowings, :list, FoyerAPI.Model.Showing, options)
    |> deserialize(:ShowingOriginatingSystemShowings, :list, FoyerAPI.Model.Showing, options)
    |> deserialize(:ShowingSourceSystemShowings, :list, FoyerAPI.Model.Showing, options)
    |> deserialize(:OriginatingSystemTeamMembers, :list, FoyerAPI.Model.TeamMembers, options)
    |> deserialize(:SourceSystemTeamMembers, :list, FoyerAPI.Model.TeamMembers, options)
    |> deserialize(:OriginatingSystemTeams, :list, FoyerAPI.Model.Teams, options)
    |> deserialize(:SourceSystemTeams, :list, FoyerAPI.Model.Teams, options)
  end
end

